#!/system/bin/sh
# For SDM 710
# By_Shenlhz

 setenforce 0

C0_GOVERNOR_DIR="/sys/devices/system/cpu/cpu0/cpufreq/schedutil"
C1_GOVERNOR_DIR="/sys/devices/system/cpu/cpu4/cpufreq/schedutil"
C0_CPUFREQ_DIR="/sys/devices/system/cpu/cpu0/cpufreq"
C1_CPUFREQ_DIR="/sys/devices/system/cpu/cpu4/cpufreq"

function set_qc()
{
	echo 1 > /sys/class/power_supply/battery/allow_hvdcp3
 chmod 755 /sys/class/power_supply/battery/constant_charge_current_max
 echo `expr 5000 \* 1000` > /sys/class/power_supply/battery/constant_charge_current_max
 chmod 755 /sys/class/power_supply/battery/input_current_max
 echo `expr 5000 \* 1000` > /sys/class/power_supply/battery/input_current_max
 echo 5000 > /sys/module/dwc3_msm/parameters/dcp_max_current
 echo 5000 > /sys/module/dwc3_msm/parameters/hvdcp_max_current
 echo 5000 > /sys/module/qpnp_smbcharger/parameters/default_dcp_icl_ma
 echo 5000 > /sys/module/qpnp_smbcharger/parameters/default_hvdcp3_icl_ma
 echo 5000 > /sys/module/qpnp_smbcharger/parameters/default_hvdcp_icl_ma
 echo 600 >/sys/class/power_supply/bms/temp_warm
 echo 100 >/sys/class/power_supply/bms/temp_cool
}

function set_param_little() 
{
	echo ${2} > ${C0_GOVERNOR_DIR}/${1}
}

function set_param_big() 
{
	echo ${2} > ${C1_GOVERNOR_DIR}/${1}
}

function print_param() 
{
	print_value "LITTLE: ${1}" ${C0_GOVERNOR_DIR}/${1}
	print_value "big: ${1}" ${C1_GOVERNOR_DIR}/${1}
}

function unify_environment() 
{
	set_value 0 /sys/module/msm_thermal/core_control/enabled
	set_value N /sys/module/msm_thermal/parameters/enabled
	lock_value "schedutil" ${C0_CPUFREQ_DIR}/scaling_governor
	lock_value "schedutil" ${C1_CPUFREQ_DIR}/scaling_governor
	stop perfd
}

function runonce_custom()
{
	set_value 90 /proc/sys/kernel/sched_spill_load
	set_value 0 /proc/sys/kernel/sched_boost
	set_value 1 /proc/sys/kernel/sched_prefer_sync_wakee_to_waker
	set_value 40 /proc/sys/kernel/sched_init_task_load
	set_value 3000000 /proc/sys/kernel/sched_freq_inc_notify
	set_value 2-3 /dev/cpuset/background/cpus
	set_value 0-3 /dev/cpuset/system-background/cpus
	set_value 0-3,4-7 /dev/cpuset/foreground/cpus
	set_value 0-3,4-7 /dev/cpuset/top-app/cpus
	lock_value 80 /sys/module/cpu_boost/parameters/input_boost_ms
	lock_value 0 /sys/module/msm_performance/parameters/touchboost
	set_param_little use_sched_load 1
	lock_value 0 ${C0_GOVERNOR_DIR}/ignore_hispeed_on_notif
	lock_value 0 ${C0_GOVERNOR_DIR}/enable_prediction
	set_param_big use_sched_load 1
	lock_value 0 ${C1_GOVERNOR_DIR}/ignore_hispeed_on_notif
	lock_value 0 ${C1_GOVERNOR_DIR}/enable_prediction
}

function before_modify()
{
	chown 0.0 ${C0_GOVERNOR_DIR}/*
	chmod 0666 ${C0_GOVERNOR_DIR}/*
	lock_value 480000 ${C0_CPUFREQ_DIR}/scaling_min_freq
	set_value 1 /sys/devices/system/cpu/cpu4/online
	chown 0.0 ${C1_GOVERNOR_DIR}/*
	chmod 0666 ${C1_GOVERNOR_DIR}/*
	lock_value 480000 ${C1_CPUFREQ_DIR}/scaling_min_freq
}

function after_modify()
{
	chmod 0444 ${C0_GOVERNOR_DIR}/*
	chmod 0444 ${C1_GOVERNOR_DIR}/*
	verify_param
}

function sdm710_custom()
{
	lock_value "0:1380000 4:2180000" /sys/module/msm_performance/parameters/cpu_max_freq
	lock_value "0:880000 4:1380000" /sys/module/cpu_boost/parameters/input_boost_freq
}



function set_value() 
{
	if [ -f $2 ]; then
		echo $1 > $2
	fi
}

function lock_value() 
{
	if [ -f $2 ]; then
		chmod 0666 $2
		echo $1 > $2
		chmod 0444 $2
	fi
}

function set_io() 
{
	if [ -f $2/queue/scheduler ]; then
		if [ `grep -c $1 $2/queue/scheduler` = 1 ]; then
			echo $1 > $2/queue/scheduler
			echo 512 > $2/queue/read_ahead_kb
			lock_value 0 $2/queue/iostats
			lock_value 256 $2/queue/nr_requests
			lock_value 0 $2/queue/iosched/slice_idle
		fi
	fi
}

function print_value() 
{
	if [ -f $2 ]; then
		echo $1
		cat $2
	fi
}

function verify_param() 
{
	expected_target=${C0_GOVERNOR_DIR}/target_loads
	if [ "$action" = "sdm710" ]; then
		expected_value="80 1080000:85"
	fi
	if [ "`cat ${expected_target}`" = "${expected_value}" ]; then
		echo "${action} OK"
	else
		echo "${action} FAIL"
	fi
}

action=$1
if [ ! -n "$action" ]; then
    action="sdm710"
fi

if [ ! -f /dev/.project_wipe ]; then
	unify_environment
fi

before_modify

if [ ! -f /dev/.project_wipe ]; then
	touch /dev/.project_wipe
	runonce_custom
	set_io cfq /sys/block/mmcblk0
	set_io cfq /sys/block/sda
	set_param_little timer_rate 20000
	set_param_little timer_slack 180000
	set_param_little boost 0
	set_param_little boostpulse_duration 0
	set_param_big timer_rate 20000
	set_param_big timer_slack 180000
	set_param_big boost 0
	set_param_big boostpulse_duration 0
fi

if [ "$action" = "sdm710" ]; then
	sdm710_custom
	set_param_little hispeed_freq 1405000
	set_param_little hispeed_load 90
	set_param_little pl 0
	set_param_big hispeed_freq 1166000
	set_param_big hispeed_load 90
	set_param_big pl 0
fi
